/**
 * $Header: /usr/home/ncvs/qmail-auditor/src/audit_controls.c,v 1.4 2003/10/12 13:18:22 nssantos Exp $
 *
 * Biblioteca resposavel pela parte de audoria.
 * Utiliza extensoes regex do sistema.
 *
 *
*/
#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <regex.h>
#include "audit_controls.h"
#include "config.h"
#include "fromto.h"
#include "errors.h"


/** Checa os fromtos e faz a auditoria dos e-mails.
*/
int check_audit() {
	FILE *fp = NULL;
	char tmpbuff[MAX_BUFF];
	int linecount = 1;
	int audit_real = 0;
	if ((fp = fopen(CONTROL_FILE, "r")) == NULL) {
		fprintf(stderr,"control config file not found in [%s]", CONTROL_FILE);
		return QQ_OTHERS;
	}	
	while (fgets(tmpbuff, MAX_BUFF, fp) != NULL) {
		char type[15], pattern[MAX_BUFF], email[MAX_BUFF];
		int audit = 0, x = 0;
		regex_t re;
		
		if (tmpbuff[0] == '#' || tmpbuff[0] == '\'' || tmpbuff[0] == '/' ||
		    tmpbuff[0] == '*' || tmpbuff[0] == '\r' || tmpbuff[0] == '\n')
		    continue;
		    
		sscanf(tmpbuff,"%s%s%s", type, pattern, email);
		if (regcomp(&re,pattern,REG_EXTENDED|REG_NOSUB) != 0) {
			fprintf(stderr,"Error in regex at line %d", linecount);
			continue;
		}
		if (strcasecmp(type,"all") == 0 || strcasecmp(type,"to") == 0) {
			for (x = 0; x < ENV_TO_NUM; x++)
				audit = regexec(&re,ENV_TO[x],0,NULL,REG_NOTBOL) == 0 || audit; 
		} 
		if (strcasecmp(type,"all") == 0 || strcasecmp(type,"from") == 0)
			audit = regexec(&re,ENV_FROM,0,NULL,REG_NOTBOL) == 0 || audit;
		regfree(&re);
		if (audit) {
			int found = 0;
			for (x = 0; x < ENV_TO_NUM; x++)
				if (strcasecmp(ENV_TO[x], email) == 0) {
					found++; 
					break;
				}
			if (!found) {
				audit_real = 1;
				ENV_TO_NUM++;
				ENV_TO = realloc(ENV_TO, ENV_TO_NUM * sizeof(char *));
				ENV_TO[ENV_TO_NUM-1] = strdup(email);
			}	
			audit = 0;
		}
		linecount++;
	}
	fclose(fp);	
	return QQ_OK;
}

