/**
 * $Header: /usr/home/ncvs/qmail-auditor/src/envelop.c,v 1.5 2003/10/12 13:18:22 nssantos Exp $
 *
 * Biblioteca responsavel pela leitura de todos os 
 * inputs do qmail-smtpd.
 * Le o FD 0 e 1, guardando as informacoes parte em memoria
 * e outra parte dentro do disco da maquina.
 *
*/
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include "config.h"
#include "envelop.h"
#include "errors.h"
#include "fromto.h"
#include "audit.h"

/** Variaveis globais do envelop
*/
char *TEMP_MESSAGE = NULL;


/** Funcao responsavel por ler todos os dados do e-mail.
*/
int read_envelop() {
	int retorno = 0;
	TEMP_MESSAGE = tempnam(TEMP_DIR,"auditor.");
	if  ((retorno = read_message(0)) == QQ_OK)
		retorno = read_fromto(1);
	return retorno;
}


/** Le a mensagem para dentro do arquivo temporario
    Parte da logica extraida para esta rotina foi pega do software
    qmail-qfilter na funcao copy_message();
*/
int read_message(int fdread) {
	int fd = open(TEMP_MESSAGE, O_CREAT | O_WRONLY);
	if (fd == -1) return QQ_READ_ENVELOP;
	for (;;) {
		char tmpbuff[MAX_BUFF];
		ssize_t numbytes = read(fdread, tmpbuff, MAX_BUFF);
		if (numbytes == -1) return QQ_READ_ENVELOP;
		if (numbytes == 0) break;
		if (write(fd, tmpbuff, numbytes) != numbytes)
			return QQ_WRITE_ERROR;
	}
	close(fd);
	chmod(TEMP_MESSAGE, S_IRWXU);
	return QQ_OK;
}



/** Le os dados de enderecamento do e-mail
    Chama a funcao de analise de fromtos.
*/
int read_fromto(int fdread) {
	char *fromto = NULL;
	int count = 0;	
	for (;;) {
		char tmpbuff[MAX_BUFF];		
		ssize_t numbytes = read(fdread, tmpbuff, MAX_BUFF);
		int x = 0;		
		if (numbytes == -1) return QQ_READ_ENVELOP;
		if (numbytes == 0) break;
		count += numbytes;
		fromto = realloc(fromto, count);
		for (; x < numbytes; x++)
			fromto[count-numbytes+x] = tmpbuff[x];
	}
	fromto_analisa(fromto);
	return QQ_OK;
}

/** Remove o envelope temporario
*/
int remove_envelop() {
	if (!flg_debug)
		unlink(TEMP_MESSAGE);
	return QQ_OK;
}

/* this function read the header of one mail, but turn slow the process.
*/
char *read_header(char *headername) {
	FILE *fp = NULL;
	char tmpbuff[MAX_BUFF];
	char tmphead[MAX_BUFF];
	char *retorno = NULL;
	
	if ((fp = fopen(TEMP_MESSAGE, "r")) == NULL) {
		fprintf(stderr,"Error reading tmpfile, container message : %s", TEMP_MESSAGE);
		return NULL;
	}
	snprintf(tmphead, MAX_BUFF, "%s:", headername);
	while (fgets(tmpbuff, MAX_BUFF,fp) != NULL) {
		if (tmpbuff[0] == '\n') break;
		if (strncmp(tmphead, tmpbuff, strlen(tmphead)) == 0) {
			int x = 0;
			retorno = malloc(strlen(tmpbuff)-strlen(tmphead));
			for (; x < strlen(tmpbuff)-strlen(tmphead)+1; x++)
				retorno[x] = tmpbuff[x+strlen(tmphead)];
			retorno[strlen(retorno)-1] = 0;
		}
	}
	fclose(fp);
	return (retorno);
}
