/*
 * $Header: /usr/home/ncvs/qmail-auditor/src/forward.c,v 1.5 2003/10/12 13:18:22 nssantos Exp $
 *
 * Funcao resposavel por remeter o envelop reformatado
 * para dentro do qmail-queue (real).
 *
 * Talvez esta tenha sido a funcao mais trabalhosa, nao
 * por sua complexidade, mas sim para a realizacao de testes
 * devido aos pipes e ao fork.
 *
*/

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "config.h"
#include "envelop.h"
#include "fromto.h"
#include "forward.h"
#include "errors.h"



int forward_email(char *queue) {
	int numtos = 0;
	while (numtos <= ENV_TO_NUM) {
		forward_email2(queue, numtos);
		numtos+= MAX_TOS;
	}
}


/** Envia o e-mail para o qmail-queue-real(?), para que este de a sequencia
    natura para o servidor.
*/
int forward_email2(char *queue, int init) {
	int fin[2], fout[2];
	int ppid = 0;
	if (pipe(fin) == -1 || pipe(fout) == -1) {
		fprintf(stderr, "forward_email(): Error creating pipes");
		return QQ_OTHERS;
	}
	ppid = fork();
	if (ppid == 0) { // child
		dup2(fin[0], 0);
		dup2(fout[0], 1);
		close(fin[0]); close(fin[1]);
		close(fout[0]); close(fout[1]);
		system(queue == NULL ? QMAIL_QUEUE : queue);
		exit(0);
	} else if (ppid > 0) {  // parent
		int fd = 0, numbytes = 0, fromto_bytes = 0;
		char *tmpstr = fromto_recreate(&fromto_bytes,init);
		char tmpbuff[MAX_BUFF];
		fd = open(TEMP_MESSAGE, O_RDONLY);
		for (;;) {
			numbytes = read(fd, tmpbuff, MAX_BUFF);
			if (numbytes == -1) return QQ_READ_ENVELOP;
			if (numbytes == 0) break;
			if (write(fin[1], tmpbuff, numbytes) != numbytes)
				return QQ_WRITE_ERROR;
		}
		close(fd);
		write(fout[1], tmpstr, fromto_bytes);
	} else {
		fprintf(stderr,"Error in fork for forward mail");
		return QQ_OTHERS;
	}
	return 0;
}
