/*
 * $Header: /usr/home/ncvs/qmail-auditor/src/fromto.c,v 1.4 2003/10/12 13:18:22 nssantos Exp $
 *
 * Biblioteca responsavel por ler, e criar um vetor em
 * memoria contendo todos os TOs (Destinos) do e-mail;
 * juntamente com o FROM.
 *
 * Esta biblioteca tambem eh utilizada para reescrever
 * todo este cabecalho de TO e FROM para o STDOUT  do
 * qmail-queue (real).
 *
 * Fator interessante, a variavel CONTROLCHAR foi definida
 * para que fosse possivel depurar o codigo via gdb.
 * Para depurar sugiro que seja trocado o valor de CONTROLCHAR
 * para | (more) de tal forma que ao digitar o STDOUT seja
 * possivel utilizar a entrada do teclado.
 * E desta forma evitar ter que criar um programa soh para
 * gerar os pipes disto. 
 *
 *
 *
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "config.h"
#include "fromto.h"
#include "errors.h"

/** Variaveis Globais
*/
char *ENV_FROM = NULL;
char **ENV_TO;
short int ENV_TO_NUM = 0;


/** Funcao que gera o vetor de ENV_TO e cria ENV_FROM
*/
int fromto_analisa(char *tmpbuff) {
	unsigned int x = 0, numbytes = 0;
	unsigned char controlfield, controlchar = 1;
	char *tmpfl = NULL;
	
	for (; !(controlchar == 1 && tmpbuff[x] == CONTROL_CHAR); x++) {
		if (controlchar && (tmpbuff[x] == 'F' || tmpbuff[x] == 'T')) {
			controlfield = tmpbuff[x];
			controlchar--;
			tmpfl = (tmpbuff+x+1);
			if (controlfield == 'T') {
				ENV_TO_NUM++;
				ENV_TO = realloc(ENV_TO, ENV_TO_NUM * sizeof(char *));
			}
			continue;	
		} else if (!controlchar && tmpbuff[x] == CONTROL_CHAR) {
			if (controlfield == 'T')
				ENV_TO[ENV_TO_NUM-1] = strdup(tmpfl);
			else if (controlfield == 'F' && tmpfl != NULL)
				ENV_FROM = strdup(tmpfl);
			tmpfl = NULL;
			controlchar++;
			continue;
		}			
	}
	return QQ_OK;
}

/** Looping para saber o tamanho a ser alocado para gerar a string de FD#1.
*/
unsigned int fromto_chuncksize(unsigned int chunkfrom, unsigned int chunckto, int toinit) {
	int x = toinit, retorno = 1;
	retorno += ((ENV_FROM != NULL) ? strlen(ENV_FROM) : 0) + chunkfrom;
	for (; x < ((toinit+MAX_TOS) > ENV_TO_NUM ?  ENV_TO_NUM : (toinit+MAX_TOS)); x++)
		retorno += ((ENV_TO[x] != NULL) ? strlen(ENV_TO[x]) : 0) + chunckto;
	return(retorno);
}


/** need think for upgrade a calc of chunk size... its a complex...
    the code is confused... and i'am now confused.. :-)
*/
char *fromto_recreate(int *numbytes, int toinit) {
	int x = toinit;
	char *tmpbuff = malloc(fromto_chuncksize(2,2,toinit));
	*numbytes = copyfromto(tmpbuff, 'F', ENV_FROM, 0);
	for (; x < ((toinit+MAX_TOS) > ENV_TO_NUM ?  ENV_TO_NUM : (toinit+MAX_TOS)); x++)
		*numbytes = copyfromto(tmpbuff, 'T', ENV_TO[x], *numbytes);
	tmpbuff[*numbytes] = CONTROL_CHAR;
	*numbytes = *numbytes + 1;
	return tmpbuff;
}

/** Copia um fromto para tmpbuff
*/
int copyfromto(char *tmpbuff, char type, char *email, int init) {
	int x = 0, len = 0;
	tmpbuff[init] = type;
	if (email != NULL) {
		for (; x < strlen(email); x++)
			tmpbuff[init+x+1] = email[x];
		len = strlen(email);
	}
	tmpbuff[init+x+1] = CONTROL_CHAR;
	return (len+2+init);	
}
